package uniandes.teolen.automatas.mundoAutomata;

import java.util.ArrayList;

		
public class SimpleUnZip extends Automata {
	
	
	 State err =  s("err");
	 State inic =  s("inic");
	 State fin =  s("fin");
				
		
	public SimpleUnZip()
	{
		super();
	
	
	   States myStates = new States() ;
	   ArrayList <State> myFinalStates = new ArrayList <State> ();
	
		State myStartState;
	  
		for (int c=1; c <= 52;  c++) { 
				   myStates.storeState(s((Integer) c));
			
		}
			
		
		
	    myStates.storeState(err);
	    myStates.storeState(inic);
	    myStates.storeState(fin);
		
		myFinalStates.add(fin);	
		
		myStartState = inic;
	
		initializeAutomata(myStates,myStartState,myFinalStates);

	}
	
	 	
	 char deCode(int code) {
		 char x ;
		 if (code < 27) 
			 x =  (char) (code-1+'a');
		 else
			 x = (char) (code-27+'A');
		 
		 return x;	 
	 }

     int code(char c)
     {
    	 if (c >= 'a' && c <= 'z') {
    		 return c - 'a'+1;
    	 }
    	 else if (c >= 'A' && c <= 'Z') {
    		 return c - 'A'+27;
    	 }
    	 else return -1;
     }
	 
     protected   State delta(State s, char c) throws Exception {
	   	
	   if (s == err) 
	      return s;
	   else if (s == fin)
		   return err;
	   else if (c == '$')
		   return fin;
	   else if (s == inic) { 
		    if (Character.isLetter(c))
		      return s(code(c));
		   else return inic;
	   }
	   else if (Character.isLetter(c)) 
		   return s(code(c));
		else 
			return inic;
	   
	 }	   
	 	   
	   
	
	
	protected String transitionOutput(State s, char c){
	   	  if (s == err) 
		      return "";
		   else if (s == fin)
			   return "";
		   if ( s == inic)
		         	   return c+"";
		   else { 
			   if  (c >= '2' && c <= '5') {
		         char c1 = deCode((Integer) s.nTh(0));
		         String resp = c1+"";
		         for (char c2  = '3';  c2 <= c ; c2++ ) {
		        	 resp += c1;
		         }
		         return resp;	 
	           }
			
			   else 
				  return c+"";
		   }
			   
	}
	
	 public String toString() {
		   return "SimpleUnZip";
	   }
}
	
