package uniandes.teolen.automatas.mundoAutomata;

import java.util.ArrayList;

		
public class SimpleZip extends Automata {
	
	
	 State err =  s("err");
	 State inic =  s("inic");
	 State fin =  s("fin");
				
		
	public SimpleZip()
	{
		super();
	
	
	   States myStates = new States() ;
	   ArrayList <State> myFinalStates = new ArrayList <State> ();
	
		State myStartState;
	  
		for (int c=1; c <= 52;  c++) { 
			for (int j=1; j <= 5; j++) { 
					   myStates.storeState(s((Integer) c,(Integer) j));
			} 
		}
			
		
		
	    myStates.storeState(err);
	    myStates.storeState(inic);
	    myStates.storeState(fin);
		
		myFinalStates.add(fin);	
		
		myStartState = inic;
	
		initializeAutomata(myStates,myStartState,myFinalStates);
	}
	
	 private String stateName(State s) {
		 
		 int  n = (Integer) s.nTh(1);
		 char c = deCode( (Integer) s.nTh(0));
		 
		 if (n == 1)
			 return  c+"";
		 else  
			 return (c + "")+ n;
		 
	 }
	
	 char deCode(int code) {
		 char x ;
		 if (code < 27) 
			 x =  (char) (code-1+'a');
		 else
			 x = (char) (code-27+'A');
		 
		 return x;	 
	 }

     int code(char c)
     {
    	 if (c >= 'a' && c <= 'z') {
    		 return c - 'a'+1;
    	 }
    	 else if (c >= 'A' && c <= 'Z') {
    		 return c - 'A'+27;
    	 }
    	 else return -1;
     }
	 
     protected   State delta(State s, char c) throws Exception {
	   	
	   if (s == err) 
	      return s;
	   else if (s == fin)
		   return err;
	   else if (c == '$')
		   return fin;
	   else if (! Character.isLetter(c)) 
		   return inic;
	   else if (s == inic) 
		   return s(code(c),1);
	   else {if (code(c) ==  (Integer) s.nTh(0)  && (Integer) s.nTh(1) < 5) 
			   return ( s(code(c), (Integer) s.nTh(1) + 1));
	   else  
			   return ( s(code(c), (Integer) 1));
	   }	   
	 }	   
	   
	
	
	protected String transitionOutput(State s, char c){
	   	  if (s == err) 
		      return "";
		   else if (s == fin)
			   return "";
		   if ( s == inic){
		       if ( Character.isLetter(c)  )
		    	   return "";
		       else
		    	   return c+"";}
		   else {
			   if (code(c) ==  (Integer) s.nTh(0)  && (Integer) s.nTh(1) < 5)
				   return "";
			   else if (Character.isLetter(c)) 
				   return   stateName(s);
			   else  return   stateName(s)+c;
		   }
			   
			   
	}
	
	 public String toString() {
		   return "SimpleZip";
	   }
}
	
